'use strict';

var CodeMirror = require('codemirror');
var CodeMirrorModeMeta = require('codemirror/mode/meta.js');
var CodeMirrorLoadMode = require('codemirror/addon/mode/loadmode.js');

var jsMode = CodeMirror.findModeByExtension('js');

jsMode.mode = 'jsx';
jsMode.ext = ['js', 'jsx', 'jsm', 'esm', 'es6'];
jsMode.alias = jsMode.ext.concat('ecmascript', 'node');
jsMode.mimes = [
  'text/jsx',
  'text/javascript',
  'text/ecmascript',
  'application/javascript',
  'application/x-javascript',
  'application/ecmascript'
];
jsMode.mimes.forEach(function (mime) {
  CodeMirror.defineMIME(mime, 'jsx');
});

var requireMode = CodeMirror.requireMode;
CodeMirror.requireMode = function (mode, cont) {
  if (mode === 'jsx') {
    // CodeMirror's dependency management is dumb
    // so we have to do this ridiculous hack...
    requireMode('javascript', function () {
      requireMode('xml', function () {
        var modeURL = CodeMirror.modeURL;
        CodeMirror.modeURL = 'codemirror-jsx';
        requireMode(mode, cont);
        CodeMirror.modeURL = modeURL;
      });
    });
  } else {
    requireMode(mode, cont);
  }
};
